#!/usr/bin/perl -w
use strict;

scalar @ARGV >= 1 or die "Usage:\n\t./generate_random_deployment.pl <number_of_machines> <latency> <bw>\n\n";
my ($nb_m,$latency,$bw) = @ARGV;
my $power=2800000000;
$latency = $latency/2;
my $i;
print "<?xml version='3'?>\n";
print "<!DOCTYPE platform SYSTEM \"simgrid.dtd\">\n";
print "<platform version=\"2\">\n";
print "<AS  id=\"AS0\"  routing=\"Full\">\n";

for($i=0;$i<$nb_m;$i++){
  print "<host id=\"$i\" power=\"$power\"/>\n";
}
print "<link id=\"loopback\" bandwidth=\"498000000\" latency=\"0.000015\" sharing_policy=\"FATPIPE\"/>\n";
for($i=0;$i<$nb_m;$i++){
  my $j=0;
  for($j=0;$j<$nb_m;$j++){
    printf "<link id=\"l_%d-%d\" bandwidth=\"%d\" latency=\"%0.10f\"/>\n", $i,$j, $bw,$latency;
  }
}
for($i=0;$i<$nb_m;$i++){
  my $j=$i;
  for($j=$i;$j<$nb_m;$j++){
    my $link=$i+$j;
    print "<route src=\"$i\" dst=\"$j\"><link_ctn id=\"loopback\"/></route>\n" if($i==$j);
    print "<route src=\"$i\" dst=\"$j\"><link_ctn id=\"l_$i-$j\"/></route>\n" unless($i==$j);
  }
}
print "</AS>\n";
print "</platform>\n";

